<?php

/**
* Gavick Weather GK4 - main file
* @package Joomla!
* @ Copyright (C) 2009-2011 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: GK4 1.0 $
**/

// access restriction
defined('_JEXEC') or die('Restricted access');

if(!defined('DS')){
   define('DS',DIRECTORY_SEPARATOR);
}

// Loading helper class
require_once (dirname(__FILE__).DS.'helper.php');

$gk_weather_key = [
    'appid' => $params->get( 'appid' , ''),
    'consumer_key' => $params->get( 'consumer_key' , ''),
    'consumer_secret' => $params->get( 'consumer_secret' , ''),
];

if ($gk_weather_key['appid'] == '' ||
    $gk_weather_key['consumer_key'] == '' ||
    $gk_weather_key['consumer_secret'] == ''
) {
    echo JText::_('CREDENTIALS_ERROR');
    return;
}

$queryValue = '';
$querySearch = [];
$gk_type = $params->get( 'gk_type' , 'woeid');
if ($gk_type == 'location') {
    $location = $params->get('location', '');
    $queryValue = $location;
}

if ($gk_type == 'woeid') {
    $woeid = $params->get('WOEID', '');
    $queryValue = $woeid;
}

if ($gk_type == 'latlong') {
    $latlong = $params->get('latlong', '');
    if ($latlong !== '') {
        $latlong = preg_replace('/\s+/', '', $latlong);
        $latlong = explode(',', $latlong);
        if (!empty($latlong[0]) && !empty($latlong[1])) {
            $querySearch['lat'] = $latlong[0];
            $querySearch['lon'] = $latlong[1];
        }
    }
}

if (empty($queryValue) && empty($querySearch)) {
    echo JText::_(strtoupper($gk_type.'_ERROR'));
    return;
}

$querySearch[$gk_type] = $queryValue;
// initialize the module and get the XML data
$helper = new GKWHelper($params, $module);
$helper->getData($gk_weather_key, $querySearch);

// try to parse the data
$helper->parseData();

// render the module output
$helper->renderLayout();

// EOF